=== debian/changelog ===
vulkan-validationlayers (1.2.189.0-1.1~mx21ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 12 Oct 2021 11:05:57 -0400

vulkan-validationlayers (1.2.189.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update shared library patch (Closes: #993994).

 -- Marc Dequènes (Duck) <Duck@DuckCorp.org>  Wed, 06 Oct 2021 14:05:10 +0900

vulkan-validationlayers (1.2.189.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 08 Sep 2021 18:44:09 +0300

vulkan-validationlayers (1.2.182.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * rules: Set USE_ROBIN_HOOD_HASHING=OFF.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 01 Sep 2021 16:38:50 +0300
